;-----------------------------------------------------------------------
; DateiName        :  zoomer.asm
;-----------------------------------------------------------------------
; Author           :  Christian Rsch
;
; Erstellungsdatum :  07.10.2001
;-----------------------------------------------------------------------
; Info : a simple zoomFX using mode 13h
;-----------------------------------------------------------------------


RTIME           equ     0               ; 1=show rastertiming
                                        ; 0=do not show rastertiming
;make sure u can see the border!



ideal
p386n


assume cs:main_code,ds:main_code


segment main_code
org 100h

main:
                mov     al,13h          ;switching to Mode 13h (VGA 320x200x256)
                int     10h

                push    0a000h          ;VGA-Segment
                pop     es

                mov     dx,3c8h         ;prepare Palette
                xor     al,al
                xor     cl,cl
                out     dx,al
                inc     dx
@@palette1:
                mov     al,cl
                call    put12
                inc     cl
                cmp     cl,65
                jnz     @@palette1

                xor     cx,cx
                xor     ax,ax

@@mainloop:
IF RTIME
                mov     dx,3dah
                in      al,dx
                mov     dx,3c0h
                mov     al,31h
                out     dx,al
                mov     al,00h          ;use color 00h for border
                out     dx,al
ENDIF

                mov     dx,3dah
                in      al,dx
                test    al,8            ;waiting for V-Retrace
                jz      $-3             ;nice way 2 make a loop ;)
                xor     di,di


IF RTIME
                mov     dx,3dah
                in      al,dx
                mov     dx,3c0h
                mov     al,31h
                out     dx,al
                mov     al,80h          ;use color 80h for border
                out     dx,al
ENDIF


                push    bp              ;push Cuunter to stack
                and     bp,255
                mov     ax,[PosY]         ;prepare Offset
                mov     [actualPosY],ax

                xor     bx,bx
                mov     bl,[sin+bp]
                shl     bx,1
                add     bx,58           ;prepare Zoom

                pop     bp
                push    bp
                add     bp,93
                shl     bp,1
                and     bp,255

                xor     ax,ax
                add     al,[sin+bp]
                shl     ax,2
                add     ax,[realPosY]
                sub     ax,64
                mov     [realPosY],ax
                mov     cx,bx
                imul    cx,100          ;=200/2
                sub     ax,cx
                mov     [PosY],ax

                pop     bp
                push    bp
                add     bp,28
                shr     bp,1
                and     bp,255

                xor     ax,ax
                add     al,[sin+bp]
                shl     ax,3
                add     ax,[realPosX]
                sub     ax,1280
                mov     [realPosX],ax
                mov     cx,bx           ;calculate upper x-row
                shl     cx,5            ;*32
                sub     ax,cx
                shl     cx,2            ;*128
                sub     ax,cx           ;128+32=160=320/2
                mov     [PosX],ax

                mov     cx,199
@@vertloop:
                mov     [ScreenY],cx
                mov     dx,320

                mov     cx,[actualPosY]    ;get actual Y
                add     cx,bx            ;calculate next Y
                mov     [actualPosY],cx    ;write back

                shr     cx,8             ;calculate Row Offset
                and     cx,31
                shl     cx,6

                mov     si,[PosX]          ;Get X-Offset
@@horloop:

                add     si,bx
                mov     ax,si
                shr     ax,8
                and     ax,63            ;Calculate column offset
                mov     bp,cx
                or      bp,ax
                mov     al,[pic+bp]

                stosb                    ;output color

                dec     dx
                jnz     @@horloop

                mov     cx,[ScreenY]
                dec     cx
                jnz     @@vertloop


                pop     bp               ;pop Counter
                inc     bp

                in      al,60h          ;Keys?
                cmp     al,1
                jnz     @@mainloop
@@theend:
                mov     al,3
                int     10h
;                jmp     cs:0
                int     20h

put12:                                 ;pushes 4 greycolors 2 palette
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                out     dx,al
                ret


  label actualPosY
        dw 0
  label ScreenY
        dw 0

  label PosX
        dw 0
  label PosY
        dw 0
  label realPosX
        dw 0
  label realPosY
        dw 0


  label pic byte

include "pic.asm"

  label sin byte

include "sin.asm"


  ends main_code
end main

;-----
; EOF
;-----